Summary: The OS Status Notification service and driver

Name: FJSVossn
Version: 3.0.0
Release: 0_2.0%{?dist}
License: GPLv2
Group: System Environment/Base
Source0: %{name}-%{version}.tar.gz
Packager: Fujitsu Limited
Vendor: Fujitsu Limited
URL: https://www.fujitsu.com/
ExclusiveOS: Linux
ExclusiveArch: x86_64
Buildroot: %{_tmppath}/%{name}-root
BuildRequires: %kernel_module_package_buildreqs gcc bash
Requires: coreutils dracut systemd kmod-%{name} ipmitool dmidecode
%systemd_requires
Requires(posttrans): systemd

%define _changelog_trimtime 0

%define kdump_config_file /etc/kdump.conf

%description
This package provides the OS Status Notification service and its
driver.

%kernel_module_package

%prep
%setup -n %{name}-%{version}

set -- *
mkdir source
mv "$@" source/
mkdir obj

%post
%systemd_post FJSVossn.service

%preun
%systemd_preun FJSVossn.service

%postun
if [ $1 -eq 0 ] ; then
  touch %kdump_config_file >/dev/null 2>&1 || :
fi

%posttrans
touch %kdump_config_file >/dev/null 2>&1 || :

%build
cd source/ossn
make CDIR=%{kernel_source default} MDIR=$PWD
cd ../../

# Sign kernel module files for Secure Boot Support
%define __modsign_install_post \
  find $RPM_BUILD_ROOT/lib/modules -type f -name '*.ko' | \
    xargs /usr/src/kernels/%{kverrel}/scripts/sign-file sha256 /usr/src/kernels/keys/priv/private_key.priv /usr/src/kernels/keys/public_key.der ; \
  find $RPM_BUILD_ROOT/lib/modules -type f -name '*.ko' | \
    xargs modinfo ; \
%{nil}

%define __spec_install_post \
  %{?__debug_package:%{__debug_install_post}}\
  %{__arch_install_post}\
  %{__os_install_post}\
  %{__modsign_install_post}\
%{nil}

%install
cd source/ossn
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{name}
make CDIR=%{kernel_source default} MDIR=$PWD install
# Cleanup unnecessary kernel-generated module dependency files.
find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
chmod u+x $RPM_BUILD_ROOT/lib/modules/*/extra/%{name}/ossn.ko
cd ../../

%define src_moddir source/for-ossn-files/dracut/modules.d/99ossn
%define src_confdir source/for-ossn-files/dracut/dracut.conf.d
%define dest_moddir %{buildroot}/usr/lib/dracut/modules.d/99ossn
%define dest_confdir %{buildroot}/usr/lib/dracut/dracut.conf.d

install -m 755 -d %{buildroot}/var/local/FJSVossn
install -m 644 source/for-ossn-files/system_index %{buildroot}/var/local/FJSVossn/system_index
install -m 755 -d %{dest_moddir}
install -m 755 %{src_moddir}/module-setup.sh %{dest_moddir}/module-setup.sh
install -m 755 %{src_moddir}/set_system_status_dumping.sh %{dest_moddir}/set_system_status_dumping.sh
install -m 755 %{src_moddir}/00-set_system_status_halt.sh %{dest_moddir}/00-set_system_status_halt.sh
install -m 644 %{src_moddir}/ossn_lib.sh %{dest_moddir}/ossn_lib.sh
install -m 755 -d %{dest_confdir}
install -m 644 %{src_confdir}/99-ossn.conf %{dest_confdir}/99-ossn.conf
install -m 755 -d %{buildroot}/etc/logrotate.d
install -m 644 source/for-ossn-files/logrotate.d.FJSVossn %{buildroot}/etc/logrotate.d/FJSVossn
install -m 755 -d %{buildroot}%{_unitdir}
install -m 644 source/for-ossn-files/systemd/system/FJSVossn.service %{buildroot}%{_unitdir}/FJSVossn.service
install -m 755 -d %{buildroot}%{_presetdir}
install -m 644 source/for-ossn-files/systemd/system-preset/98-ossn.preset %{buildroot}%{_presetdir}/98-ossn.preset
install -m 755 -d %{buildroot}%{_bindir}
install -m 755 source/ossn/ossn.sh %{buildroot}/usr/bin/ossn

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
/var/local/FJSVossn/system_index
/usr/lib/dracut/modules.d/99ossn/module-setup.sh
/usr/lib/dracut/modules.d/99ossn/set_system_status_dumping.sh
/usr/lib/dracut/modules.d/99ossn/00-set_system_status_halt.sh
/usr/lib/dracut/modules.d/99ossn/ossn_lib.sh
/usr/lib/dracut/dracut.conf.d/99-ossn.conf
/etc/logrotate.d/FJSVossn
/usr/lib/systemd/system/FJSVossn.service
/usr/lib/systemd/system-preset/98-ossn.preset
/usr/bin/ossn

%changelog
* Tue Jun 20 2023 Fujitsu Limited - 3.0.0-0_2.0
- Add support of RHEL9.2 (BS01729, BS01732, BS01733)
- Add support of PRIMEQUEST 4000 series. (BS01733)
* Tue Jan 17 2023 Fujitsu Limited - 3.0.0-0_1.0
- Add support of RHEL9.1 (BS01715)
* Tue Jul 19 2022 FUJITSU LIMITED - 3.0.0-0
- Add support of RHEL9 (BS01707)
* Tue Jun 22 2021 FUJITSU LIMITED - 2.0.2-0
- Fix hang during system panic caused by the deadlock in printk exclusive control logic. (BS01691, BS01693)
* Thu May 23 2019 FUJITSU LIMITED - 2.0.1-0
- Fix failure of starting sadump when HBA blockage function fails on Extended Partition environment (BS01673)
- Fix wrong value of Build Host in the rpm package information (BS01672, BS01673)
* Wed Mar 6 2019 FUJITSU LIMITED - 2.0.0-0
- Add support of RHEL8 on PRIMEQUEST with HBA blockage function (BS01670)
- Add support of RHEL8 on PRIMERGY (BS01669)
* Fri Nov 24 2017 FUJITSU LIMITED - 1.0.0-2
- Fix the wrongly configured value in add_drivers+= in the dracut.conf file. (BS01642)
* Tue Aug 8 2017 FUJITSU LIMITED - 1.0.0-1
- Add support of Extended Partitioning on PRIMEQUEST 3000 series E model. (BS01633)
* Fri Apr 21 2017 FUJITSU LIMITED - 1.0.0-0
- FJSVossn was newly packaged. (BS01630)

